Attribute VB_Name = "WORLD1"
Global Const xpoint1% = 4320: '360 degrees x 12 (5 minute intervals)
Global Const xpoint2% = 4319: 'Ditto for the ETOPO5.DAT version
Global Const yline% = 2160: '180 degrees x 12 (N Pole to S Pole)
Global fname$, maptype%, colplan%, ptsperpixel, grid%, mapwidth%, path$, etype%
Global r%, g%, b%
Global lat%, lon%, lat2%, lon2%, fsave$, xpoint%

Type etopo
x(xpoint1%) As Integer
End Type

Type etopoD
x(xpoint2%) As Integer
End Type

Sub setcolours(ByVal colplan%, ByVal alt%)
Dim g0%, f, f2
'Set colour shadings

Select Case colplan%
Case 0: 'FLAT GREEN
   Select Case alt%
   Case Is < 0: r% = 0: b% = 127: g% = 0
   Case Is >= 0: r% = 0: b% = 0: g% = 160
   End Select
Case 1: 'GRADUATED GREEN
   f = (7000 - alt%) / 7000: 'Scaling factor
   Select Case alt%
   Case Is < 0: r% = 0: b% = 127: g% = 0
   Case Is >= 0: r% = 40: b% = 0: g% = 60 + 120 * f
   End Select
Case 2: 'GRADUATED GREEN + BATHYMETRY
   f = (7000 - alt%) / 7000: 'Scaling factor
   f2 = alt% / 8000: 'Scaling factor
   Select Case alt%
   Case Is < 0: r% = 0: b% = 255 - 64 * (2 - f2): g% = 0
   Case Is >= 0: r% = 40: b% = 0: g% = 60 + 120 * f
   End Select
Case 4: 'OLIVE RELIEF
   f = alt% / 8000
   Select Case alt%
   Case Is < 0:  r% = 0: b% = 127: g% = 0
   Case 0 To 500: r% = 48 + f * 192: g% = 64 + f * 192: b% = 223 * f
   Case Is > 500: r% = 64 + f * 192: g% = 64 + f * 192: b% = 223 * f
 End Select
Case 5: ' OLIVE RELIEF + BATHYMETRY
   f = alt% / 8000
   Select Case alt%
   Case Is < 0: r% = 0: b% = 255 - 64 * (2 - f): g% = 0
   Case 0 To 500: r% = 48 + f * 192: g% = 64 + f * 192: b% = 223 * f
   Case Is > 500: r% = 64 + f * 192: g% = 64 + f * 192: b% = 223 * f
 End Select
Case 7: 'COLOURED RELIEF + KEY
   Select Case alt%
   Case Is < 0: r% = 0: b% = 127: g% = 0
   Case 0 To 100: r% = 0: g% = 176: b% = 0
   Case 101 To 250: r% = 16: g% = 160: b% = 0
   Case 251 To 500: r% = 32: g% = 144: b% = 0
   Case 501 To 1000: r% = 48: g% = 128: b% = 0
   Case 1001 To 1500: r% = 64: g% = 112: b% = 0
   Case 1501 To 2000: r% = 64: g% = 96: b% = 0
   Case 2001 To 2500: r% = 80: g% = 88: b% = 16
   Case 2501 To 3000: r% = 96: g% = 96: b% = 32
   Case 3001 To 4000: r% = 96: g% = 96: b% = 64
   Case 4001 To 5000: r% = 112: g% = 112: b% = 80
   Case 5001 To 5300: r% = 120: g% = 96: b% = 80
   Case Is > 5300: r% = 224: g% = 224: b% = 255
   End Select
Case 8: 'COLOURED RELIEF + KEY + BATHYMETRY
   f = (10500 + alt%) / 10000
   Select Case alt%
   Case Is < -200:  r% = 0: b% = 224 * f: g% = 0
   Case -200 To -1: r% = 0: b% = 224: g% = 0
   Case 0 To 100: r% = 0: g% = 176: b% = 0
   Case 101 To 250: r% = 16: g% = 160: b% = 0
   Case 251 To 500: r% = 32: g% = 144: b% = 0
   Case 501 To 1000: r% = 48: g% = 128: b% = 0
   Case 1001 To 1500: r% = 64: g% = 112: b% = 0
   Case 1501 To 2000: r% = 64: g% = 96: b% = 0
   Case 2001 To 2500: r% = 80: g% = 88: b% = 16
   Case 2501 To 3000: r% = 96: g% = 96: b% = 32
   Case 3001 To 4000: r% = 96: g% = 96: b% = 64
   Case 4001 To 5000: r% = 112: g% = 112: b% = 80
   Case 5001 To 5300: r% = 120: g% = 96: b% = 80
   Case Is > 5300: r% = 224: g% = 224: b% = 255
   End Select
End Select
End Sub

Public Function SwitchBytes%(n%)
Dim f$, s$, q$, k%
q$ = Hex(n%): ' convert to Hex
k% = Len(q$)
If Len(q$) < 4 Then q$ = Right$("000" + q$, 4): 'restore leading zeros
f$ = Mid$(q$, 1, 2)
s$ = Mid$(q$, 3, 2)
q$ = s$ + f$: 'Swap MSB LSB
n% = CDec(Val("&H" + q$)): 'convert back to Decimal
SwitchBytes% = n%
End Function
